#!/usr/bin/env python
# check_mailstorelicence.py - checks the amount of free licences
#
# Copyright (c) 2012,2013 MailStore Software GmbH
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicence, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# MailStore Management API connection setti
HOST = "localhost"
USER = "admin"
PASS = "admin"
PORT = 8463

boughtLicences = 100
criticalThreshold = 5
warningThreshold = 10

################### DON'T CHANGE ANYTHING BELOW THIS LINE ###################

import sys
import mailstoreapi

if __name__ == "__main__":
    api = mailstoreapi.ManagementAPI(USER,PASS,HOST,PORT)
    usedLicences = len(api.GetUserList()) - 1#-1 because admin does not count
    freeLicences = boughtLicences - usedLicences
    if  freeLicences <= criticalThreshold:
        print("MAILSTORELICENCE critical - amount of free licences ({0}) is below criticalThreshold ({1})|boughtLicences={2}, freeLicences={0}, threshold={1}".format(freeLicences, criticalThreshold, boughtLicences))
        sys.exit(2)
    elif  freeLicences <= warningThreshold:
        print("MAILSTORELICENCE warning - amount of free licences ({0}) is below warningThreshold ({1})|boughtLicences={2}, freeLicences={0}, threshold={1}".format(freeLicences, warningThreshold, boughtLicences))
        sys.exit(1)
    else:
        print("MAILSTORELICENCE ok - amount of free licences ({0}) is larger than warningThreshold ({1})|boughtLicences={2}, freeLicences={0}, threshold={1}".format(freeLicences, warningThreshold, boughtLicences))
        sys.exit(0)
